<template>
  <div>
    <table>
      <tr :key="outerIndex" v-for="(pieceArray, outerIndex) in this.piecePositions">
        <td
          is="Cell"
          v-for="(piece, innerIndex) in pieceArray"
          :key="innerIndex"
          :ref="`${outerIndex}${innerIndex}`"
          :piece="piece.name"
          :styling="piece.styling"
          :isPlayerOne="piece.isPlayerOne"
          :xPosition="outerIndex"
          :yPosition="innerIndex"
          :turnCounter="turnCounter"
          @handleClickedCell="handleClickedCell($event)"
          @handleHoverCell="handleHoverCell($event)"
        />
      </tr>
    </table>

    <div></div>
    <button @click="move" v-show="showMoveButton">Move</button>
    <button @click="attack" v-show="showAttackButton">Attack</button>
    <button @click="endTurn">End Turn</button>
  </div>
</template>

<script lang="ts">
import { Vue, Component, Prop } from "vue-property-decorator";
import Cell from "./Cell.vue";
import {
  handleMovementGameState,
  handleAttackGameState,
  handleDefaultGameState,
  handlePreGameGameState
} from "../utilities/makeMoveFunctions.vue";
import {
  PieceName,
  PieceInfo,
  DamageType,
  MovementPossibility,
  AttackPossibility,
  Styling,
  Position
} from "../models/pieceModels";
import { GameState } from "../models/boardModels";
import { defaultPiece } from "../utilities/defaultPieceInfo";
import { AITurn } from "../utilities/singlePlayerFunctions.vue";

@Component({
  components: {
    Cell
  }
})
export default class Board extends Vue {
  @Prop() readonly boardSelectedPiece!: PieceName | null;
  @Prop() readonly boardPlayerTurn!: boolean;
  @Prop() readonly maxNumberOfSelectedPieces!: number;
  @Prop() readonly isSinglePlayer!: boolean;

  public turnCounter = 1;
  public isPlayerOneTurn: boolean = this.boardPlayerTurn;
  public noOfAlivePieces = 0;
  public gameState: GameState = GameState.PREGAME;
  public selectedPiece: PieceInfo = defaultPiece;
  public movementPossibilities: MovementPossibility[] = [];
  public attackPossibilities: AttackPossibility[] = [];
  public piecePositions: PieceInfo[][] = Array.from(Array(8)).map(() =>
    Array.from(Array(8)).map(() => this.selectedPiece)
  );
  public showMoveButton = false;
  public showAttackButton = false;

  public handleClickedCell(position: Position): void {
    const { xPosition, yPosition } = position;
    const movementPossibility =
      this.gameState === GameState.MOVEMENT &&
      this.movementPossibilities.find(
        possibility => possibility.xPosition === xPosition && possibility.yPosition === yPosition
      );

    const attackPossibility =
      this.gameState === GameState.ATTACK &&
      this.attackPossibilities.find(
        possibility => possibility.xPosition === xPosition && possibility.yPosition === yPosition
      );

    switch (this.gameState) {
      case GameState.MOVEMENT:
        if (movementPossibility) {
          handleMovementGameState(this, movementPossibility);
        }

        this.resetStyling();
        this.gameState = GameState.DEFAULT;
        break;
      case GameState.ATTACK:
        if (attackPossibility) {
          handleAttackGameState(this, this.piecePositions[xPosition][yPosition], attackPossibility);
        }

        this.resetStyling();
        this.gameState = GameState.DEFAULT;
        break;
      case GameState.PREGAME:
        handlePreGameGameState(this, xPosition, yPosition);
        break;
      default:
        handleDefaultGameState(
          this,
          this.piecePositions[xPosition][yPosition],
          xPosition,
          yPosition
        );
        break;
    }
  }

  public move() {
    this.movementPossibilities.forEach(possibility => {
      const { xPosition, yPosition } = possibility;
      this.updatePiecePositions((x, y, position) => {
        if (x === xPosition && y === yPosition) {
          return {
            ...this.piecePositions[xPosition][yPosition],
            styling: Styling.MOVEMENT_HIGHLIGHT
          };
        }

        return position;
      });
    });
    this.gameState = GameState.MOVEMENT;
    this.showMoveButton = false;
    this.showAttackButton = false;
  }

  public attack() {
    this.attackPossibilities.forEach(possibility => {
      const { xPosition, yPosition } = possibility;

      this.updatePiecePositions((x, y, position) => {
        if (x === xPosition && y === yPosition) {
          return position.isPlayerOne !== this.selectedPiece.isPlayerOne
            ? { ...position, styling: Styling.ATTACK_HIGHLIGHT }
            : position;
        }

        return position;
      });
    });
    this.gameState = GameState.ATTACK;
    this.showMoveButton = false;
    this.showAttackButton = false;
  }

  public resetStyling() {
    this.updatePiecePositions((x, y, position) => ({ ...position, styling: Styling.DEFAULT }));
  }

  public async endTurn() {
    this.isPlayerOneTurn = !this.isPlayerOneTurn;
    this.turnCounter += 1;
    this.gameState = GameState.DEFAULT;
    this.selectedPiece = defaultPiece;
    this.showMoveButton = false;
    this.showAttackButton = false;
    this.reset();
    this.$emit("addPiece", this.isPlayerOneTurn);

    if (this.isSinglePlayer) {
      await AITurn(this);
      this.isPlayerOneTurn = !this.isPlayerOneTurn;
      this.turnCounter += 1;
      this.$emit("addPiece", this.isPlayerOneTurn);
    }
  }

  public updatePiecePositions(updateFn: (x: number, y: number, position: PieceInfo) => PieceInfo) {
    this.piecePositions = this.piecePositions.map((positionArray, x) =>
      positionArray.map((position, y) => updateFn(x, y, position))
    );
  }

  public reset(): void {
    this.updatePiecePositions((x, y, position) => {
      return {
        ...position,
        movementTokens: this.piecePositions[x][y].movement,
        hasAttacked: false,
        styling: Styling.DEFAULT
      };
    });
  }

  private handleHoverCell(position: Position): void {
    this.$emit("handleStatusMessage", this.piecePositions[position.xPosition][position.yPosition]);
  }
}
</script>

<style>
.button {
  margin-bottom: 40px;
  vertical-align: middle;
}
.disappear {
  display: none;
}
</style>
